<?php
/*
Plugin Name: Multiplayer Games
Version: 2.0.5
Plugin URI: http://www.dimensionex.net/en/wordpress_multiplayer_plugin.htm
Description: Provides free web-based multiplayer games to be run inside any WordPress website
Author: Cristiano Leoni
Author URI: http://www.dimensionex.net/

Quick Start:

1) Activate the Plugin
2) Place #games in any of your pages
3) Enjoy games (for playing games we recommend using Mozilla Firefox browser)

*/

/*************************************/
// CONFIGURATION
/*************************************/

$dx_embeddedplay = 1;		// Do you want embedded playing? 1=YES 0=NO (0 = plays games in fullscreen window)
$dx_embedded_width=640;		// width of the window for the embedded game.
$dx_embedded_height=480;	// height of the window for the embedded game. Must match with $dx_embedded_width.
							// Please choose 640 x 480 or 800 x 600 or 1024 x 768

/*************************************/
// END OF CONFIGURATION
/*************************************/


/*

More docs for the clever:

Template Functions:

dx_get_games(page_id,category)


Example of use:
insert in your template the following PHP code:

echo dx_get_games();

	This one will produce a complete list of all the available games

	or

echo dx_get_games($id,"");

	This one will produce a list of the games related with that page

Notes:
This version has got configurable embedded play.
"Embedded play" means that you allow visitors to play in a IFRAME created within your own web site page.
Since this version you can choose whether you want embedded play or not (embedded blay is default)
see the global variable definition: $dx_embeddedplay below.
To customize the look of the game page just edit the template: multiplayerlist.php

Versions History:

+ 2.0.5 - 2008/10/28
	Added Boundary City game
	Fixed bug that was producing double prints of games when different servers were registered
	Functions renamed for readability
	Tested under WP 2.6.3
+ 2.0 - 2008/05/19
	Tested under Wordpress 2.5.1
	Bugs corrected
	Used filtering method: #gameslist for inserting the games list
+ 1.6
    Used 640x480 as default resolution
+ 19.4.2007  1.4, 1.5
    Re-packaged
+ 18.4.2007  1.3
    Added thumbnails and 1 game to the list (Four-in-Line)
+ 1.2.2006 1.2
    Adaptation to Wordpress 2.1
+ 18.7.2005  1.1
	Allows embedded play (plays game inside your WordPress site - embedded window)
+ 14.7.2005  1.0
	First working version
+ 12.6.2005  0.2
    Admin part is working
+ 30.6.2005  0.1
    First version (based on Downloads 0.2b by Philipp Baer)

many thanks to Philipp Baer as part of this work is based on his

Released under the GPL license
http://www.gnu.org/licenses/gpl.txt

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


define("DX_FORM", "MultiplayerGames");
define("DX_SERVERS_FORM", "MultiplayerServers");

$sizes = array('bytes', 'kbytes', 'mbytes', 'gbytes', 'tbytes');
$datefmt = "d.m.Y";//, H:i:s";

/*
$dx_new = -1;
$dx_edit = -1;
$dx_commit = -1;
$dx_mapping_new = -1;
$dx_mapping_edit = -1;
$dx_mapping_commit = -1;
$dx_page_id = -1;
$dx_show_category = '';
$dx_error = '';
$dx_commited = false;
*/

/*
 * Create tables required by the plugin
 */
function dx_create_tables() {
    global $wpdb;

    $wpdb->query(
        "CREATE TABLE IF NOT EXISTS $wpdb->dxgames (
         id INTEGER UNSIGNED NOT NULL auto_increment,
         server INTEGER NOT NULL default 0,
         slot VARCHAR(255) NOT NULL default 'noslot',
         name VARCHAR(50) NOT NULL default 'untitled',
         description VARCHAR(255) NOT NULL default '',
         thumb VARCHAR(255) NOT NULL default '',
         category VARCHAR(64) NOT NULL default '',
         owner INTEGER NOT NULL default 1,
         page INTEGER NOT NULL default 0,
         position INTEGER NOT NULL default 0,
         date DATETIME NOT NULL default '0000-00-00 00:00:00',
         creation_date DATETIME NOT NULL default '0000-00-00 00:00:00',
		PRIMARY KEY(id))");

   // servers table
    $wpdb->query(
        "CREATE TABLE IF NOT EXISTS $wpdb->dxservers (
         id INTEGER UNSIGNED NOT NULL auto_increment,
         name VARCHAR(64) NOT NULL default '',
         url VARCHAR(255) NOT NULL default '',
         PRIMARY KEY(id))");
}


/*
 * Fills game table with (working!) demo games
 */
function dx_fill_tables() {
    global $wpdb;

   // servers table
   $server = $wpdb->get_var("SELECT MAX(id) FROM $wpdb->dxservers WHERE NAME='Gamesclan.it'");

   if (!$server) {
    $wpdb->query(
        "INSERT INTO $wpdb->dxservers (url,name) VALUES ('http://www.gamesclan.it/dimx/servlet/multiplayer','Gamesclan.it')");
		$server = $wpdb->get_var("SELECT MAX(id) FROM $wpdb->dxservers");
	}

	// Display on ANY page using the "Multiplayer Games List" (multiplayerlist.php) template
	$page = -1;

   // games table

	$category = "1 - MMORPG";

	// Add Underworld
    $game = $wpdb->get_var("SELECT MAX(id) FROM $wpdb->dxgames WHERE NAME='Underworld'");
	if (!$game) {
    	$query =
            "INSERT INTO $wpdb->dxgames(name, description, thumb, server, slot, category, page, position, date, creation_date)" .
            "VALUES(" .
            "'Underworld', " .
            "'Fantasy RPG taking place in a cursed castle. Several character types to choose from.', 'http://www.dimensionex.net/it/images/underworld.jpg'," .
            $server . ", " .
            "5, " .
            "'$category', " .
            $page . ", " .
            dx_game_next_free_position($page, $category) . ", " .
            "'" . current_time('mysql') . "', " .
            "'" . current_time('mysql') . "')";
		$wpdb->query($query);
	}

	// Add Network Arena
    $game = $wpdb->get_var("SELECT MAX(id) FROM $wpdb->dxgames WHERE NAME='NetWork Arena'");
	if (!$game) {
    	$query =
            "INSERT INTO $wpdb->dxgames(name, description, thumb, server, slot, category, page, position, date, creation_date)" .
            "VALUES(" .
            "'NetWork Arena', " .
            "'NetWork Arena is a virtual world where your goal is to destroy Viruses or other Navigators in the network.', 'http://www.dimensionex.net/en/images/netarena.jpg'," .
            $server . ", " .
            "7, " .
            "'$category', " .
            $page . ", " .
            dx_game_next_free_position($page, $category) . ", " .
            "'" . current_time('mysql') . "', " .
            "'" . current_time('mysql') . "')";
		$wpdb->query($query);
	}

	$category = "2 - Multiplayer Adventure";

	// Add The Beach
    $game = $wpdb->get_var("SELECT MAX(id) FROM $wpdb->dxgames WHERE NAME='The Beach'");
	if (!$game) {
    	$query =
            "INSERT INTO $wpdb->dxgames(name, description, thumb, server, slot, category, page, position, date, creation_date)" .
            "VALUES(" .
            "'The Beach', " .
            "'You are on a far distant island, where strange people live. Will you find the hidden treasure before your opponents do?', 'http://www.dimensionex.net/en/images/thebeach.jpg'," .
            $server . ", " .
            "4, " .
            "'$category', " .
            $page . ", " .
            dx_game_next_free_position($page, $category) . ", " .
            "'" . current_time('mysql') . "', " .
            "'" . current_time('mysql') . "')";
		$wpdb->query($query);
	}

	// Add Boundary City
    $game = $wpdb->get_var("SELECT MAX(id) FROM $wpdb->dxgames WHERE NAME='Boundary City'");
	if (!$game) {
    	$query =
            "INSERT INTO $wpdb->dxgames(name, description, thumb, server, slot, category, page, position, date, creation_date)" .
            "VALUES(" .
            "'Boundary City', " .
            "'(educational) Boundary City is a community that teaches young people how to \"just say NO\" to drugs and make healthy choices.', 'http://www.dimensionex.net/en/images/online5.jpg'," .
            $server . ", " .
            "10, " .
            "'$category', " .
            $page . ", " .
            dx_game_next_free_position($page, $category) . ", " .
            "'" . current_time('mysql') . "', " .
            "'" . current_time('mysql') . "')";
		$wpdb->query($query);
	}

	$category = "3 - Board";

	// Add FourInLine
    $game = $wpdb->get_var("SELECT MAX(id) FROM $wpdb->dxgames WHERE NAME='Four-In-Line'");
	if (!$game) {
    	$query =
            "INSERT INTO $wpdb->dxgames(name, description, thumb, server, slot, category, page, position, date, creation_date)" .
            "VALUES(" .
            "'Four-In-Line', " .
            "'Challenge your opponent: Place four pieces in line. A classic board game.', 'http://www.dimensionex.net/turnbased/images/fourin1_small.jpg'," .
            $server . ", " .
            "17, " .
            "'$category', " .
            $page . ", " .
            dx_game_next_free_position($page, $category) . ", " .
            "'" . current_time('mysql') . "', " .
            "'" . current_time('mysql') . "')";
		$wpdb->query($query);
	}

	/*

   // Add dragondice server
   $server = $wpdb->get_var("SELECT MAX(id) FROM $wpdb->dxservers WHERE NAME='dragondiceonline.com'");

   if (!$server) {
    $wpdb->query(
        "INSERT INTO $wpdb->dxservers (url,name) VALUES ('http://www.dragondiceonline.com/servlet/multiplayer','dragondiceonline.com')");
		$server = $wpdb->get_var("SELECT MAX(id) FROM $wpdb->dxservers");
	}

	$category = "3 - Board";

	// Add Dragon Dice
    $game = $wpdb->get_var("SELECT MAX(id) FROM $wpdb->dxgames WHERE NAME='Dragon Dice'");
	if (!$game) {
    	$query =
            "INSERT INTO $wpdb->dxgames(name, description, thumb, server, slot, category, page, position, date, creation_date)" .
            "VALUES(" .
            "'Dragon Dice', " .
            "'An RPG board game, please check out the game rules on the <a href=\"http://www.dragondiceonline.com/\">website</a> before playing', 'http://www.dimensionex.net/en/images/dragondice.jpg'," .
            $server . ", " .
            "1, " .
            "'$category', " .
            $page . ", " .
            dx_game_next_free_position($page, $category) . ", " .
            "'" . current_time('mysql') . "', " .
            "'" . current_time('mysql') . "')";
		$wpdb->query($query);
	}

	*/

}


/*
 * Drops game tables
 */
function dx_drop_tables() {
    global $wpdb;

	$row = @$wpdb->get_row("SELECT DISTINCT(thumb) FROM $wpdb->dxgames");

	if (!$row) { // Transition from old version - remove table
		$wpdb->query("DROP TABLE $wpdb->dxgames");
		$wpdb->query("DROP TABLE $wpdb->dxservers");
		echo "Please ignore this error - database was adjusted - please hit REFRESH<p><br><p>";
	}
}


/*
 * Loads url-localdir-mappings from the database
 */
function dx_load_mappings() {
    global $wpdb;
    global $mappings;

    $results = $wpdb->get_results(
        "SELECT * FROM $wpdb->dxservers");

    if ($results) {
        foreach ($results as $result) {
            $mappings[$result->url] = $result->localpath;
        }
    }
}


/*
 * Initialize Downloads
 * - Setup database
 * - Load url-localdir-mappings
 */
function dx_initialize() {
    global $table_prefix;
    global $wpdb;

    // Register database names
    $wpdb->dxgames = $table_prefix . 'dxgames';
    $wpdb->dxservers = $table_prefix . 'dxservers';

    // Create tables in database if required
    dx_create_tables();

    // Load mappings from database
    dx_load_mappings();

}


/*
 * Returns the value of $name if it is an integer
 * $default otherwise.
 */
function dx_get_int($name, $default = NULL) {
    $result = $default;

    // Get the value if it is an integer
    if (isset($_REQUEST[$name])) {
        if (is_numeric($_REQUEST[$name])) {
            $result = $_REQUEST[$name];
        }
    }

    return $result;
}


/*
 * Echoes out a list (option fields for select) of categories for the passed page id.
 * If the page id is -1, all categories are returned
 */
function dx_get_category_list($page = -1) {
    global $wpdb;
    $filter = "";

    if ($page > -1) {
        $filter = "WHERE page=$page ";
    }

    $results = $wpdb->get_results(
        "SELECT DISTINCT category " .
        "FROM $wpdb->dxgames " .
        $filter .
        "ORDER BY category");

    foreach ($results as $row) {
?>
          <option value="<?php echo $row->category; ?>"<?php echo ($category == $row->category ? " selected=\"selected\"" : ""); ?>><?php echo wp_specialchars($row->category); ?></option>
<?php
    }
}


/*
 * Echoes out a list (option fields for select) of categories for the passed page id.
 * If the page id is -1, all categories are returned
 */
function dx_get_server_list($server) {
    global $wpdb;

    $results = $wpdb->get_results(
        "SELECT * " .
        "FROM $wpdb->dxservers " .
        "ORDER BY name");

    foreach ($results as $row) {
?>
          <option value="<?php echo $row->id; ?>"<?php echo ($server == $row->id ? " selected=\"selected\"" : ""); ?>><?php echo wp_specialchars($row->name); ?></option>
<?php
    }
}


/*
 * Remove a server
 */
function dx_mapping_remove($id) {
    global $wpdb;
    $wpdb->query(
        "DELETE FROM $wpdb->dxservers WHERE id=$id");
}


/*
 * Remove a game
 */
function dx_remove($id) {
    global $wpdb;

	// Remove file
    $results = $wpdb->get_results(
        "SELECT * " .
        "FROM $wpdb->dxgames " .
        "WHERE id=$id");

	if ($results) {
		foreach ($results as $row) {
			$wpdb->query(
				"DELETE FROM $wpdb->dxgames WHERE id=$id");
		}
	} else {
	   echo ("Unexistent> $id");
	}
	return;


}


/*
 * Get the next free position withing a category in a page
 */
function dx_game_next_free_position($page_id, $category) {
    global $wpdb;

    $result = $wpdb->get_var(
        "SELECT MAX(position) " .
        "FROM $wpdb->dxgames ".
        "WHERE page=$page_id AND category='$category'");

    return (isset($result) ? $result + 1 : 0);
}


/*
 * Move a game entry within a category in a page one position up
 */
function dx_game_move_up($id) {
    global $wpdb;

    $row = $wpdb->get_row(
        "SELECT id, page, category, position " .
        "FROM $wpdb->dxgames WHERE id=$id");

    // Check if there is such a row
    if ($row) {
        $position = $row->position;

        // Move element up iff position is greater than 0
        if ($position > 0) {
            $position--;

            $prevrow = $wpdb->get_row(
                "SELECT id, position " .
                "FROM $wpdb->dxgames " .
                "WHERE page=$row->page AND category='$row->category' AND position<=$position " .
                "ORDER BY position DESC");

            // If there is a previous element, move it one position down
            if ($prevrow) {
                $position = $prevrow->position;
                $prevrow_position = $position + 1;
                $wpdb->query(
                    "UPDATE $wpdb->dxgames " .
                    "SET position=$prevrow_position WHERE id=$prevrow->id");
            }

            // Move the current element one to the new position
            $wpdb->query(
                "UPDATE $wpdb->dxgames " .
                "SET position=$position " .
                "WHERE id=$id");
        }
    }
}


/*
 * Move a game entry within a category in a page one position down
 */
function dx_game_move_down($id) {
    global $wpdb;

    $row = $wpdb->get_row(
        "SELECT id, position, page, category " .
        "FROM $wpdb->dxgames WHERE id=$id");

    // Check if there if such a row
    if ($row) {
        $position = $row->position;

        // Get the last game id
        $next_free = dx_game_next_free_position(
            $row->page,
            $row->category) - 1;

        // Move element down iff we're not at the end of the list
        if ($next_free > $row->position)  {
            $position++;

            $nextrow = $wpdb->get_row(
                "SELECT id, position " .
                "FROM $wpdb->dxgames " .
                "WHERE page=$row->page AND category='$row->category' AND position>=$position " .
                "ORDER BY position ASC");

            // If there is a previous element, move it one position up
            if ($nextrow) {
                $position = $nextrow->position;
                $nextrow_position = $position - 1;
                $wpdb->query(
                    "UPDATE $wpdb->dxgames " .
                    "SET position=$nextrow_position " .
                    "WHERE id=$nextrow->id");
            }

            // Move the current element one to the new position
            $wpdb->query(
                "UPDATE $wpdb->dxgames " .
                "SET position=$position " .
                "WHERE id=$id");
        }
    }
}


/*
 * Create or commit changes for new/existent mapping
 */
function dx_servers_commit_changes($id, $url, $localpath) {
    global $wpdb;

    if ($id > -1) {
        // If an id is given, try to update the entriy
        $query =
            "UPDATE $wpdb->dxservers " .
            "SET url='$url', name='$localpath' " .
            "WHERE id=$id";

    } else {
        // Otherwise insert a new one
        $query =
            "INSERT INTO $wpdb->dxservers(url, name) " .
            "VALUES(" .
            "'$url', " .
            "'$localpath')";
    }

    // Fire query :)
    $wpdb->query($query);
}


/*
 * Create or commit changes for new/existent game
 */
function dx_commit_changes($id, $name, $description, $thumb, $server, $slot, $category, $page) {
    global $wpdb;

    if ($id > -1) {
        // If an id is given, try to update the entry
        $query =
            "UPDATE $wpdb->dxgames " .
            "SET name='$name', description='$description', thumb='$thumb', server='$server', slot='$slot', category='$category', page=$page, date='" . current_time('mysql') . "' " .
            "WHERE id=$id";

    } else {
        // Otherwise insert a new entry after the last one
        $query =
            "INSERT INTO $wpdb->dxgames(name, description, thumb, server, slot, category, page, position, date, creation_date)" .
            "VALUES(" .
            "'$name', " .
            "'$description', " .
          	"'$thumb', " .
            "'$server', " .
            "'$slot', " .
            "'$category', " .
            $page . ", " .
            dx_game_next_free_position($page, $category) . ", " .
            "'" . current_time('mysql') . "', " .
            "'" . current_time('mysql') . "')";
    }

    // Fire query :)
    $wpdb->query($query);
}


/*
 * Form for adding a server
 */
function dx_server_edit_form($id = 0, $url = '', $localpath = '') {
    global $wpdb;

?>
  <div class="wrap">
    <form name="mapping_edit" method="post" action="<?php echo $_SERVER[PHP_SELF]; ?>?page=<?php echo DX_SERVERS_FORM; ?>">
<?php

    // If an id is given, an existing entry is modified. Silently pass the
    // id as a hidden parameter
    if ($id > 0) {
?>
      <input type="hidden" name="dx_id" value="<?php echo $id; ?>" />
<?php
    }

?>
      <input type="hidden" name="dx_action" value="mapping_commit" />
      <table style="border: 0;">
        <tr>
          <td>Name:</td>
          <td><input type="text" SIZE="50" name="dx_mapping_localpath" value="<?php echo $localpath; ?>" /></td>
        </tr>
        <tr>
          <td>URL:</td>
          <td><input type="text" SIZE="80" name="dx_mapping_url" value="<?php echo $url; ?>" /></td>
        </tr>
      </table><br />
      <input type="submit" name="submit" value="submit">
    </form>
  </div>
<?php
}


/*
 * Form for editing/creating a game entry
 */
function dx_edit_form($id = 0, $name = 'untitled', $description = '', $thumb = '', $server = "", $slot = '', $category = 0, $page_id = -1) {
    global $wpdb;

?>
  <div class="wrap">
    <form enctype="multipart/form-data" name="edit" method="post" action="<?php echo $_SERVER[PHP_SELF]; ?>?page=<?php echo DX_FORM; ?>">
      <!-- MAX_FILE_SIZE must precede the file input field -->
      <input type="hidden" name="MAX_FILE_SIZE" value="30000000" />
<?php

    // If an id is given, an existing entry is modified. Silently pass the
    // id as a hidden parameter
    if ($id > 0) {
?>
      <input type="hidden" name="dx_id" value="<?php echo $id; ?>" />
<?php
    }

?>
      <input type="hidden" name="dx_action" value="commit" />
      <table style="border: 0;">
        <tr>
          <td>Server:</td>
          <td width="40%">
            <select name="dx_server_id">
			<?php dx_get_server_list($server); ?>
            </select>
          </td>
          <td>Choose from the list. If the list is empty, then add a server with the Servers tab.</td>
        </tr>
        <tr>
          <td>Slot:</td>
          <td><input type="text" name="dx_slot" SIZE="8" value="<?php echo $slot; ?>" /></td>
          <td>Write here the slot associated to the game. This is usually a number like 1,2,3...</td>
        </tr>
        <tr>
          <td>Name:</td>
		  <td><input type="text" name="dx_name" SIZE="20" value="<?php echo $name; ?>" /></td>
          <td>Name of the game</td>
        </tr>
        <tr>
          <td>Description:</td>
          <td><TEXTAREA NAME="dx_description" ROWS="4" COLS="30"><?php echo($description); ?></TEXTAREA>
          </td>
          <td>Brief description of the game. May contain up to 255 characters.</td>
        </tr>
        <tr>
          <td>Thumbnail URL:</td>
          <td><TEXTAREA NAME="dx_thumb" ROWS="4" COLS="30"><?php echo($thumb); ?></TEXTAREA>
          </td>
          <td>URL to game's thumbnail. May contain up to 255 characters.</td>
        </tr>
        <tr>
          <td>Page:</td>
          <td>
            <select name="dx_page_id">
              <option value="-1"<?php echo ($dpage_id == -1 ? " selected=\"selected\"" : ""); ?>>*any page*</option>
              <?php parent_dropdown($page_id); ?>
            </select>
          <td>If you like thise entry to be associated to a particular page, choose here. If unsure, choose <B>*any page*</B>.<BR><B>Tip</B>: To test, create a page using the "Multiplayer Games List" template (multiplayerlist.php file must be copied in your theme's folder)</td>
          </td>
        </tr>
        <tr>
          <td>Group:</td>
          <td>
            <select name="dx_category">
<?php

    // Print out all categories
    dx_get_category_list();

?>
            </select><BR>...or new:
            <input type="text" name="dx_category_new" value="" />
          </td>
          <td>Use this one to group entries together (by genre, language, etc.). If unsure, just leave blank.</td>
        </tr>
      </table><br />
      <input type="submit" name="submit" value="submit">
    </form>
  </div>
<?php
}


/*
 * Register the plugin with the management console
 * - Register management page
 * - Call dx_initialize
 */
function dx_register() {
    global $table_prefix;
    global $wpdb;
    global $dx_show_category;
    global $dx_page_id;
    global $dx_edit;
    global $dx_mapping;
    global $dx_mapping_edit;
    global $dx_mapping_commit;
    global $dx_error;
    global $dx_commited;
    global $dx_db;
    global $dx_map_db;
    global $dx_trigger_action;

    if (function_exists('add_options_page')) {
        add_management_page(__('MultiplayerGames'), __('Multiplayer Games'), 0, DX_FORM, 'dx_display_management_panel');
        add_management_page(__('MultiplayerServers'), __('Multiplayer Servers'), 0, DX_SERVERS_FORM, 'dx_display_management_panel_mappings');
    }

	if (isset($_GET['activate']) && $_GET['activate'] == 'true') {
		dx_fill_tables();
	}

	if (isset($_GET['action']) && $_GET['action'] == 'deactivate') {
		//dx_drop_tables();
	}

    // Initialize plugin
    dx_initialize();

    // Check for the category that should be displayed
    $dx_show_category = '';
    if (isset($_POST['dx_show_category'])) {
        // Use parameter value
        $dx_show_category = $_POST['dx_show_category'];
    } else if (isset($_COOKIE['dx_show_category_' . COOKIEHASH])) {
        // Use cookie information
        $dx_show_category = $_COOKIE['dx_show_category_' . COOKIEHASH];
    }

    // Check for the page that should be displayed
    $dx_page_id = dx_get_int('dx_page_id');
    if (isset($_REQUEST['dx_page_id'])) {
        // Reset current category if the page selection changed
        if (isset($_COOKIE['dx_page_id_' . COOKIEHASH])) {
            if ($dx_page_id != $_COOKIE['dx_page_id_' . COOKIEHASH]) {
                $dx_show_category = '';
            }
        }

    } else if (isset($_COOKIE['dx_page_id_' . COOKIEHASH])) {
        // Use cookie information
        $dx_page_id = $_COOKIE['dx_page_id_' . COOKIEHASH];
    }
    if ($dx_page_id == NULL) {
        $dx_page_id = -1;
    }

    // Store new cookies
    setcookie('dx_show_category_' . COOKIEHASH, $dx_show_category, time() + 600);
    setcookie('dx_page_id_' . COOKIEHASH, $dx_page_id, time() + 600);

    // Initialize the global variables that indicate which input form
    // should be displayed.
    $dx_trigger_action = '';
    $dx_edit = -1;

    // Check the action
    if (isset($_REQUEST['dx_action'])) {
        switch ($_REQUEST['dx_action']) {
            case 'mapping_new':
            case 'new':
                // Trigger creation of a new game or gameserver mapping
                $dx_trigger_action = $_REQUEST['dx_action'];
                break;

            case 'mapping_commit':
                $commit = -1;
                $dx_commited = false;

                // Get the item id, if this is an updatea
                if (isset($_REQUEST['dx_id'])) {
                    $commit = dx_get_int('dx_id');
                    if ($commit == NULL) {
                        // The parameter value is not an integer... abort
                        break;
                    }
                }

                // At least these two parameters must be present
                if ((isset($_REQUEST['dx_mapping_url'])) &&
                    (isset($_REQUEST['dx_mapping_localpath'])))
                {
                    // Sanitize strings
                    $url = wp_specialchars($_REQUEST['dx_mapping_url']);
                    $localpath = wp_specialchars($_REQUEST['dx_mapping_localpath']);

                    // Check if the URL is valid (for our purposes)
                    $urltest = parse_url($url);
                    if ((strlen($urltest['scheme']) > 0) &&
                        (strlen($urltest['host']) > 0))
                    {
                        // Commit changes
                        dx_servers_commit_changes(
                            $commit,
                            $url,
                            $localpath);

                        // Indicate successful commitment
                        $dx_commited = true;

                    } else {
                        // An error occured, nothing's be commited
                        $dx_error = "Error inserting mapping! Please enter a valie URL!";
                    }
                } else {
                    $dx_error = "Please specify URL and Localpath!";
                }
                break;

            case 'commit':
                $commit = -1;
                $dx_commited = false;

                // Get the item id, if this is an update
                $commit = dx_get_int('dx_id');
                if ($commit == NULL) {
                    $commit = -1;
                }

                // At least these three parameters must be present
                if ($_REQUEST['dx_page_id'] && $_REQUEST['dx_slot'])
                {
                	// Get the server ID and slot ID
                	$server = $_REQUEST['dx_server_id'];
                	$slot = $_REQUEST['dx_slot'];

                    // Get the category to which the item should be added
                    if ((isset($_REQUEST['dx_category_new'])) && ($_REQUEST['dx_category_new'] != "")) {
                        // If dx_category_new is available, a new category is created
                        $category = $_REQUEST['dx_category_new'];

                    } else {
                        // Otherwise the dx_category variable must be present
                        if (!isset($_REQUEST['dx_category']))
                            $category = "Miscellanous";
                        else
                        	$category = $_REQUEST['dx_category'];
                    }

                    // Get the page on which these game should be shown
                    $dx_page_id = dx_get_int('dx_page_id');
                    if ($dx_page_id == NULL) {
                        // The parameter value is not an integer... abort
                        $dx_page_id = -1;
                        break;
                    }

                    // Sanitize parameters
                    $description = $_REQUEST['dx_description'];
                    $description = wp_specialchars($description);
                    $name = $_REQUEST['dx_name'];
                    $name = wp_specialchars($name);
                    $thumb = $_REQUEST['dx_thumb'];
                    $thumb = wp_specialchars($thumb);
                    $category = wp_specialchars($category);

                    // Commit changes
                    dx_commit_changes(
                        $commit,
                        $name,
                        $description,
                        $thumb,
                        $server,
                        $slot,
                        $category,
                        $dx_page_id);

                    // Indicate successful commitment
                    $dx_commited = true;

                } else {
                    // An error occured, nothing's be commited
                    $dx_error = "Please specify a page on which this game should be displayed!";
                }
                break;

            case 'mapping_delete':
                $id = dx_get_int('dx_id');
                if ($id != NULL) {
                    // Remove the specified mapping
                    dx_mapping_remove($id);
                }
                break;

            case 'delete':
                $id = dx_get_int('dx_id');
                if ($id != NULL) {
                    // Remove the specified game
                    dx_remove($_REQUEST['dx_id']);
                }
                break;

            case 'mapping_edit':
                // Get the id for the mapping to edit
                $dx_mapping_edit = dx_get_int('dx_id');
                break;

            case 'edit':
                // Get the id for the game to edit
                $dx_edit = dx_get_int('dx_id');
                break;

            case 'move_up':
                // Move the game one position up
                $id = dx_get_int('dx_id');
                if ($id != NULL) {
                    dx_game_move_up($id);
                }
                break;

            case 'move_down':
                // Move the game one position down
                $id = dx_get_int('dx_id');
                if ($id != NULL) {
                    dx_game_move_down($id);
                }
                break;
        }
    }
}

/*
 * Form for options (not implemented yet)
 */
function dx_display_options_panel() {
    if (isset($_POST['info_update'])) {
?>
  <div class="updated"><p><strong>
    <?php _e('Process completed fields in this if-block, and then print warnings, errors or success information.', 'Localization name') ?>
  </strong></p></div>

<?php
    }

?>
  <div class=wrap>
    <form method="post">
      <h2>WP Downloads</h2>
      <fieldset name="set1">
        <legend><?php _e('Options set 1', 'Localization name') ?></legend>
        Put some form input areas here.
      </fieldset>
      <fieldset name="set2">
        <legend><?php _e('Options set 2', 'Localization name') ?></legend>
        Put some more form input areas here.
      </fieldset>
      <div class="submit">
        <input type="submit" name="info_update" value="<?php _e('Update options', 'Localization name') ?> »" >
      </div>
    </form>
  </div>
<?php
}


/*
 * Form for managing games
 */
function dx_display_management_panel() {
    global $wpdb;
    global $dx_show_category;
    global $dx_page_id;
    global $dx_trigger_action;
    global $dx_edit;
    global $dx_error;

    // If an error occured, print out the message
    if ($dx_error != '') {
?>
    <div class="wrap">
        <div style="font-weight: bold; color: #f00; text-align: center;"><?php echo $dx_error; ?></div>
    </div>
<?php
    }

    // If an action was triggered, display the corresponding form
    if ($dx_trigger_action == 'new') {
        dx_edit_form();

    } else if ($dx_edit > -1) {
        /* $row = $wpdb->get_row(
            "SELECT g.*, s.name " .
            "FROM $wpdb->dxgames as g, $wpdb->dxservers as s " .
            "WHERE g.id=$dx_edit AND g.server = s.id"); */
        $row = $wpdb->get_row(
            "SELECT g.* " .
            "FROM $wpdb->dxgames as g " .
            "WHERE g.id=$dx_edit");

        dx_edit_form(
            $dx_edit,
            $row->name,
            $row->description,
            $row->thumb,
            $row->server,
            $row->slot,
            $row->category,
            $row->page);
    }

?>
  <div class="wrap">
    <form name="cats" method="post" action="">
      <table width="100%" cellpadding="3" cellspacing="3">
        <tr>
          <td><?php _e('<strong>Page</strong>:'); ?></td>
          <td><?php _e('<strong>Show</strong> games in group:'); ?><br /></td>
          <td>&nbsp;</td>
        </tr>
        <tr>
          <td>
            <select name="dx_page_id">
              <option value="-1"<?php echo ($dx_page_id == -1 ? " selected=\"selected\"" : ""); ?>>*any page*</option>
              <?php parent_dropdown($dx_page_id); ?>
            </select>
          </td>
          <td>
            <select name="dx_show_category">
              <option value=""<?php echo ($dx_show_category == "" ? " selected=\"selected\"" : ""); ?>>All</option>
<?php

    // Print out all categories
    dx_get_category_list();

?>
            </select>
        </td>
       <td style="text-align:right;">
          <input type="submit" name="action" value="Show" />
        </td>
      </tr>
    </table>
  </form>
</div>
<form name="links" id="links" method="post" action="">
  <div class="wrap">
    <input type="hidden" name="dx_link_id" value="" />
    <input type="hidden" name="dx_action" value="" />
    <input type="hidden" name="dx_page_id" value="-1" />
    <input type="hidden" name="dx_show_category" value="" />
<?php

    $filter = "WHERE g.server = s.id ";

    // If a specific category was chosen, define a filter
    if ($dx_show_category != "") {
        $filter .= " AND category='" . $dx_show_category . "' ";
    }

    // If a page was specified filter the results, too
    if ($dx_page_id != -1) {
        $filter .= " AND page=$dx_page_id ";
    }

    $results = $wpdb->get_results(
        "SELECT g.*, s.url " .
        "FROM $wpdb->dxgames AS g, $wpdb->dxservers AS s " .
        $filter .
        "ORDER BY g.category, g.position");

?>
      <table stye="border: 0; width: 100%;" width="100%">
<?php

    if ($results) {
        // Go through the results an list all games for each category
        $styles = array();
        $styles[] = '';
        $styles[] = 'alternate';

        $old_category = '';
        $i = 0;
        foreach ($results as $row) {
            // Once the category name changed, insert a new header
            if ($old_category != $row->category) {
?>
        <tr>
          <td colspan="4">
            <br />
            <h2><?php echo $row->category; ?></h2>
          </td>
        </tr>
<?php
            }

            // Track the category name
            $old_category = $row->category;
?>
        <tr class="<?php echo $styles[$i]; ?>">
          <td>
          <a href="<?php echo $row->url . "?game=" . $row->slot; ?>" title="<?php echo $row->name; ?>"><?php echo($row->name); ?></a>
          </td>
          <td style="width: 60%">
            <?php echo $row->description; ?>
          </td>
          <td style="text-align: right; width: 20%">
            (<?php echo $row->date; ?>)
          </td>
          <td style="text-align: right; width: 20%">
            <a href="<?php echo $_SERVER[PHP_SELF]; ?>?page=<?php echo DX_FORM; ?>&dx_id=<?php echo $row->id; ?>&dx_action=edit">Edit</a>
            <a href="<?php echo $_SERVER[PHP_SELF]; ?>?page=<?php echo DX_FORM; ?>&dx_id=<?php echo $row->id; ?>&dx_action=delete" onclick="return confirm('You are about to delete this link.\n  \'Cancel\' to stop, \'OK\' to delete.');">Delete</a>
            <a href="<?php echo $_SERVER[PHP_SELF]; ?>?page=<?php echo DX_FORM; ?>&dx_id=<?php echo $row->id; ?>&dx_action=move_up">Up</a>
            <a href="<?php echo $_SERVER[PHP_SELF]; ?>?page=<?php echo DX_FORM; ?>&dx_id=<?php echo $row->id; ?>&dx_action=move_down">Down</a>
          </td>
        </tr>
<?php
            $i++;
            $i %= 2;
        }
    }

?>
    </table>
    <h3><a href="<?php echo $_SERVER[PHP_SELF]; ?>?page=<?php echo DX_FORM; ?>&dx_action=new">New Game &raquo;</a></h3>
  </div>
</form>
<?php
}


/*
 * Form for managing mappings
 */
function dx_display_management_panel_mappings() {
    global $wpdb;
    global $dx_trigger_action;
    global $dx_mapping_edit;
    global $dx_mapping_commit;
    global $dx_commited;
    global $dx_error;

    // If an error occured, print out the error message
    if ($dx_error != '') {
    	echo '<div class="wrap">
        <div style="font-weight: bold; color: #f00; text-align: center;">'. $dx_error .'</div>
    </div>';

        // If data was not commited, display the edit form again
        if (!$dx_commited) {
            dx_server_edit_form(
                $dx_mapping_commit,
                $_REQUEST['dx_mapping_url'],
                $_REQUEST['dx_mapping_localpath']);
        }
    }
    // If an action was triggered, display the corresponding form
    if ($dx_trigger_action == 'mapping_new') {
        dx_server_edit_form();

    } else if ($dx_mapping_edit > -1) {
        $row = $wpdb->get_row(
            "SELECT * " .
            "FROM $wpdb->dxservers " .
            "WHERE id=$dx_mapping_edit");

        dx_server_edit_form(
            $dx_mapping_edit,
            $row->url,
            $row->name);
    }

?>
  <div class="wrap">
    A <i>DimensioneX Server</i> is a web server equipped with the DimensioneX game engine, offering free multiplayer games to public.<br />
    A server consists of a base url (URL of the game engine).
  </div>
<form name="downloadmappings" id="links" method="post" action="">
  <div class="wrap">
    <input type="hidden" name="dx_mappings_action" value="" />
      <table style="border: 0; width: 100%;" width="100%">
        <tr>
          <th style="text-align: left;">Name</th>
          <th style="text-align: left;">URL</th>
          <th></th>
        </tr>
<?php

    // Get the mappings
    $results = $wpdb->get_results(
        "SELECT * " .
        "FROM $wpdb->dxservers " .
        "ORDER BY id");

    // Print each mapping
    if ($results) {
        $styles = array();
        $styles[] = '';
        $styles[] = 'alternate';

        $i = 0;
        foreach ($results as $row) {
?>
        <tr class="<?php echo $styles[$i]; ?>">
          <td style="width: 35%;">
            <?php echo $row->name; ?>
          </td>
          <td style="width: 35%;">
            <?php echo $row->url; ?>
          </td>
          <td style="width: 30%; text-align: right;">
            <a href="<?php echo $_SERVER[PHP_SELF]; ?>?page=<?php echo DX_SERVERS_FORM; ?>&dx_id=<?php echo $row->id; ?>&dx_action=mapping_edit">Edit</a>
            <a href="<?php echo $_SERVER[PHP_SELF]; ?>?page=<?php echo DX_SERVERS_FORM; ?>&dx_id=<?php echo $row->id; ?>&dx_action=mapping_delete" onclick="return confirm('You are about to delete this link.\n  \'Cancel\' to stop, \'OK\' to delete.');">Delete</a>
          </td>
        </tr>
<?php
            $i++;
            $i %= 2;
        }
    }

?>
    </table>
    <br />
    <h3><a href="<?php echo $_SERVER[PHP_SELF]; ?>?page=<?php echo DX_SERVERS_FORM; ?>&dx_action=mapping_new">Add Game Server &raquo;</a></h3>
  </div>
</form>
<?php
}


/*
 * Template function:
 * Get all games. The result is filtered depending on the page and the category.
 */
function dx_get_games($pageid = -1, $category = "") {
    global $wpdb;
    global $dx_db;
    global $sizes;
    global $datefmt;

    dx_loop_load($pageid, $category);

    $result = "<TABLE BORDER CELLPADDING=\"5\" CELLSPACING=\"0\" WIDTH=\"100%\">\n";
    while (dx_loop_next()) {
        $result .= dx_loop_get_category('<TR><TD COLSPAN="3"><H3>', "</H3></TR>\n");
        $result .= "<TR><TD WIDTH=\"110\">" . dx_loop_get_players() . "<BR>" . dx_loop_get_whosonlink("Who's there?") . "</TD>";
        $result .= "<TD>" . dx_loop_get_thumb(dx_loop_url_builder("<a title=\"" . dx_loop_get_name() . "\" href=\"", "\">") . '<img src="','" width=100 height=70 /></a>') . dx_loop_get_name("<div class=\"dx_link\">" . dx_loop_url_builder("<a title=\"" . dx_loop_get_name() . "\" href=\"", "\">"), "</a></div>\n") . "</TD>";
        $result .= "<TD>" . dx_loop_get_description("<div class=\"dx_description\">", "</div>\n");
        $result .= "</TD></TR>";
    }
	$result .= "</TABLE>";

    return $result;
}


/*
 * Reset the output loop
 */
function dx_loop_reset() {
    global $dx_loop_entries_start;
    global $dx_loop_entries;
    global $dx_loop_first;
    global $dx_loop_category;

    $dx_loop_entries = $dx_loop_entries_start;
    $dx_loop_first = true;
    $dx_loop_category = '';
}


/*
 * Initialize the output loop
 */
function dx_loop_load($pageid = -1, $category = '') {
    global $wpdb;
    global $dx_loop_entries_start;
    global $dx_loop_entries;
    global $dx_loop_first;
    global $dx_loop_category;

    $dx_loop_category = '';
    $dx_loop_first = true;

    $filter = "WHERE g.server = s.id ";
    // If a page id if given, modify the filter as required
    if ($pageid != -1) {
        $filter .= "AND page=$pageid OR page=-1 ";
    }

    // If a category name is given, modify the filter as required
    if ($category != "") {
        $filter .= "AND category='$category' ";
    }


    $dx_loop_entries = $wpdb->get_results(
        "SELECT g.*,s.url " .
        "FROM $wpdb->dxgames as g, $wpdb->dxservers as s " .
        $filter .
        "ORDER BY category, position");

    $dx_loop_entries_start = $dx_loop_entries;
}


/*
 * Continue with the next element in the output loop
 */
function dx_loop_next() {
    global $dx_loop_entries;
    global $dx_loop_first;

    if ($dx_loop_first) {
        $dx_loop_first = false;
        if ($dx_loop_entries) {
            return (current($dx_loop_entries) != false);
        } else {
            return false;
        }
    }

    return (next($dx_loop_entries) != false);
}


/*
 * Returns the current category. If this was already done an empty string
 * is retunred instead
 */
function dx_loop_get_category($before = '', $after = '') {
    global $dx_loop_entries;
    global $dx_loop_category;

    $dbo = current($dx_loop_entries);

    if ($dbo) {
	$category = $dbo->category;
        if ($category != $dx_loop_category) {
            $dx_loop_category = $category;
            return $before . ($category) . $after;
        }
    }

    return '';
}


/*
 * Returns the current game's url builder
 */
function dx_loop_url_builder() {
    global $dx_loop_entries;
    global $dx_embeddedplay;

    $dbo = current($dx_loop_entries);

	if ($dx_embeddedplay) {
		return "<script language=\"javascript\">embeddedurl(\"" . ($dbo->url) . "QQQgame=" . ($dbo->slot) . "\");</script><noscript>Javascript must be ENABLED</noscript>";
	} else {
		return "<script language=\"javascript\">genurl(\"" . ($dbo->url) . "?game=" . ($dbo->slot) . "\");</script><noscript>Javascript must be ENABLED</noscript>";
	}
}


/*
 * Returns the current game's real (physical) url
 */
function dx_loop_get_url() {
    global $dx_loop_entries;

    $dbo = current($dx_loop_entries);

	return ($dbo->url) . "?game=" . ($dbo->slot);
}


/*
 * Returns the current game's link for embedded play
 */
function dx_loop_get_embeddedurl() {
    global $dx_loop_entries;

    $dbo = current($dx_loop_entries);
	$fixedurl = dx_loop_get_url();
	$fixedurl = str_replace("?","QQQ",$fixedurl);
	return "<SCRIPT language=\"javascript\">embeddedurl(\"" . $fixedurl . "\")</SCRIPT>" . $prompt . "</A>";
}

/*
 * Returns the player's IFRAME
 */
function dx_loop_get_players() {
    global $dx_loop_entries;

    $dbo = current($dx_loop_entries);

	return "<IFRAME WIDTH=\"100\" HEIGHT=\"26\" SCROLLBARS=\"0\" SCROLLING=\"off\" SRC=\"" . ($dbo->url) . "?game=" . $dbo->slot . "&amp;view=players\"></IFRAME>";
}

/*
 * Returns the "Who's there" link
 */
function dx_loop_get_whosonlink($prompt = 'Who\'s there?') {
    global $dx_loop_entries;

    $dbo = current($dx_loop_entries);
	$fixedurl = dx_loop_get_url();
	$fixedurl = str_replace("?","QQQ",$fixedurl);
	return "<SCRIPT language=\"javascript\">whosthere(\"" . $fixedurl . "\")</SCRIPT>" . $prompt . "</A>";
}


/*
 * Returns the current game's description
 */
function dx_loop_get_description($before = '', $after = '') {
    global $dx_loop_entries;

    $dbo = current($dx_loop_entries);

    return $before . ($dbo->description) . $after;
}

/*
 * Returns the current game's name
 */
function dx_loop_get_name($before = '', $after = '') {
    global $dx_loop_entries;

    $dbo = current($dx_loop_entries);

    return $before . $dbo->name . $after;
}

/*
 * Returns the current game's thumb
 */
function dx_loop_get_thumb($before = '', $after = '') {
    global $dx_loop_entries;

    $dbo = current($dx_loop_entries);

    return $before . $dbo->thumb . $after;
}


/*
 * Returns the current date
 */
function dx_loop_get_date($before = '', $after = '', $fmt = 'd.m.Y') {
    global $dx_loop_entries;

    $dbo = current($dx_loop_entries);

    return $before . (date($fmt, strtotime($dbo->date))) . $after;
}

function dx_contentfilter($content = '') {
	$view = $_REQUEST['view'];

	if (strpos($content,'#games')) {
		$games_content = dx_thescripts();

		switch ($view) {
			case 'whosthere':
				$games_content .= dx_thewhostherepage();
				break;
			case 'play':
				$games_content .= dx_theembeddedplaypage();
				break;
			default:
				$games_content .= dx_get_games();
		}
		$content = str_replace('#games',$games_content,$content);
	}
	return $content;
}

function dx_thescripts() {
global $dx_embedded_width,$dx_embedded_height;
$url_array = explode("&", $_SERVER['REQUEST_URI']);
// Now remove view and url data - they will be re-added by the javascript
foreach ($url_array as $i=>$value) {
	if (substr($url_array[$i],0,5)=='view=') {
		unset($url_array[$i]);
	} else if (substr($url_array[$i],0,4)=='url=') {
		unset($url_array[$i]);
	} else if (substr($url_array[$i],0,6)=='width=') {
		unset($url_array[$i]);
	} else if (substr($url_array[$i],0,6)=='height=') {
		unset($url_array[$i]);
	}
}
$urlfinal = implode('&',$url_array);

return '<script type="text/javascript" language="JavaScript">
function launch(url) {
	// Startup code for the client
	var w = screen.width - 10;
	var h = screen.height - 100;
	var attrs = "resizable=1,status=1,scrollbars=1,directories=0,toolbar=1,menubar=0,left=0,top=0,width="+w+",height="+h;
	//alert("\'" + attrs + "\'");
	//game = window.open(url + "?width="+screen.width+"&height="+screen.height,\'game\',"\'" + attrs + "\'");
	this.document.location.href = url + "&width="+screen.width+"&height="+screen.height;
}
function genurl(url) {
	// Startup code for the client
	document.write (\'<a href="\' + url + "&width="+screen.width+"&height="+screen.height + \'">\');
}
function whosthere(url) {
	// Who s there link
	document.write (\'<a href="\' + location.href + "&view=whosthere&url=" + url + \'">\');
}
function embeddedurl(url) {
	// Embedded play link
	document.write (\'<a href="'.$urlfinal.'&view=play&url=\' + url + \'&width='.$dx_embedded_width.'&height='.$dx_embedded_height.'">\');
}
function embeddedplay(url) {
	// Embedded play window
	document.write (\'<iframe width="98%" height="480" src="\' + url + \'&width='.$dx_embedded_width.'&height='.$dx_embedded_height.'" ></iframe>\');
}
</script>';
}

function dx_thewhostherepage() {
	global $dx_embeddedplay;

	$url = $_REQUEST["url"];
	$realurl = str_replace("QQQ","?",$url);

	$ret = '	<div id="whosthere">
	<P><BR></P><H2>Who\'s There?</H2>';
	$ret .= "<iframe width=\"98%\" height=\"300\" scrollbars=\"auto\" scrolling=\"auto\" src=\"" . $realurl . "&amp;view=players&amp;format=extended\"></iframe>";
	if ($dx_embeddedplay) {
		$ret .= "<h1><script type=\"text/javascript\" language=\"Javascript\">embeddedurl(\"" . $url . "\");</script>Connect Now!</a></h1>";
	} else {
		$ret .= "<h1><script type=\"text/javascript\" language=\"Javascript\">genurl(\"" . $realurl . "\");</script>Connect Now!</a></h1>";
	}
	$ret .= '</div><!-- closes DIV id=whosthere -->';
	return $ret;
}

function dx_theembeddedplaypage() {
	global $dx_embeddedplay;


	$url = $_REQUEST["url"];
	$realurl = str_replace('QQQ','?',$url);

	$ret = '	<div id="play">';

	$ret .= '<script type="text/javascript" language="Javascript">embeddedplay("'.$realurl.'");</script>';
	//$ret .= "<iframe width=\"98%\" height=\"480\" scrollbars=\"auto\" scrolling=\"auto\" src=\"".$realurl.'"></iframe>';

	$ret .= '</div><!-- closes DIV id=play -->';
	return $ret;
}


// Register hooks
add_action('admin_menu', 'dx_register');
add_action('plugins_loaded', 'dx_initialize');
add_filter('the_content', 'dx_contentfilter');
?>
